/**
 * Ephoto Dam Addon for Drupal 8
 *
 * @base EPHOTO DAM
 * @author EINDEN - Tous droits réservés
 */

(function ($) {
	
	var EphotoDam = {
		zoomIn: function(img) {
			var overlay = $('#ephoto-dam-overlay').length ? $('#ephoto-dam-overlay'): $('<div id="ephoto-dam-overlay"></div>').appendTo('body');
			var wrap = $('#ephoto-dam-wrap').length ? $('#ephoto-dam-wrap'): $('<div id="ephoto-dam-wrap"><div id="ephoto-dam-close"></div><img></div>').appendTo('body');

			var buffer = new Image();
			
			buffer.onload = function() {
				var width, height, ratio = buffer.width / buffer.height;

				if(ratio < 1.0) {
					height = document.documentElement.clientHeight - 100;
					width = Math.floor(height * ratio);
					
				} else {
					width = document.documentElement.clientWidth - 100;
					height = Math.floor(width * ratio);
				};
				
				var close = function(event) {
					event.stopPropagation();
					event.stopImmediatePropagation();
				
					wrap.fadeOut(300);
					overlay.delay(250).fadeOut(300);	
				};

				wrap.children().last().attr('src', img.src);
				
				wrap.children().first().on('click', close);

				wrap.css({
					'width': width,
					'height': height,
					'margin-left': -(Math.floor(width / 2) + 8),
					'margin-top': -(Math.floor(height / 2) + 8)
				
				}).delay(250).fadeIn(300);

				overlay.fadeIn(300).on('click', close);
			};
			
			buffer.src = img.src;
		},
	};
	
	$('img.ephoto-dam-zoom').on('click', function(event) {
		event.stopPropagation();
		event.stopImmediatePropagation();
		
		EphotoDam.zoomIn(this);	
	});
	
})(jQuery);
